/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* Cherokee
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2001-2002 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __CHEROKEE_MIME_H__
#define __CHEROKEE_MIME_H__

#include "common.h"
#include "table.h"
#include "server.h"

typedef struct {
	cherokee_table_t table;
} cherokee_mime_t;



ret_t cherokee_mime_init           (cherokee_mime_t **mime);
ret_t cherokee_mime_init_with_file (cherokee_mime_t **mime, char *filename);
ret_t cherokee_mime_get_default    (cherokee_mime_t **mime);

ret_t cherokee_mime_free           (cherokee_mime_t  *mime);

char* cherokee_mime_get            (cherokee_mime_t  *mime, char *ext);

#endif /* __CHEROKEE_MIME_H__ */
